local T = CBW_EggRoboTag

//Master display script
T.EggDisplayControl = function(mo)
	local player = mo.player
	if (player.pflags&PF_TAGIT) or (T.CV_Debug.value == 2)//or (player.iseggrobo)
		if P_PlayerInPain(player) and not(mo.tagged) then //Transforming
			if not(player.eggrobo_transforming) then
				T.DebugPrint("tagged player has been colorized")
				mo.colorized = true
				S_StartSound(nil,sfx_cdfm44)
				player.eggrobo_transforming = true
			end
			mo.color = P_RandomRange(1,113)
		else //Transformed
			if player.eggrobo_transforming then
				T.DebugPrint("tagged player color reset")
				mo.color = player.skincolor
				mo.colorized = false
				player.eggrobo_transforming = false
			end
			T.EggRoboDisplay(mo)
		end
	return end //end of function
end

//EggRobo display states
T.EggRoboDisplay = function(mo)
	local player = mo.player
	//Initiate EggRobo
	if mo.tagged == nil then
		if not(player.iseggrobo) then
			local dummy = P_SpawnMobjFromMobj(mo,0,0,0,MT_JETDUMMY)
			dummy.target = mo
			A_BossJetFume(dummy,4)
			player.iseggrobo = true //We are the eggrobo now.
		end
		mo.tagged = true
		if mo.health == 0 and P_MobjFlip(mo)*mo.momz < 0 then player.iseggrobo = false end
	end
	player.followitem = MT_NULL
	player.charflags = $|SF_MACHINE
	player.camerascale = FRACUNIT*3/2
	//EggRobo was killed
	if player.iseggrobo and player.playerstate == PST_DEAD then 
		player.iseggrobo = false
		T.DummySpawnLimbs(mo,target)
	end

	if player.playerstate == PST_DEAD then //Set death sprite
		P_SetMobjStateNF(mo,S_EGGROBODEAD)
	return end //Important that we don't run anything after this line
	
	//Death state
	if P_PlayerInPain(player) then
		player.powers[pw_nocontrol] = 2
		player.ert_state = -1
		P_SetMobjStateNF(mo, S_EGGROBOTAG2)
	elseif mo.state != S_EGGROBOTAG2 or P_IsObjectOnGround(mo)
		player.powers[pw_flashing] = min($,TICRATE*2)
		if player.ert_state == -1
			player.ert_state = 0
		end
		P_SetMobjStateNF(mo, S_EGGROBOTAG1)
	end
end

//MobjFlip for  jet fumes
T.JetThink = function(mo)
	if not(mo.target and mo.target.valid and mo.target.target) then return end
	if P_MobjFlip(mo.target.target) == -1
		mo.flags2 = $|MF2_OBJECTFLIP
		mo.eflags = $|MFE_VERTICALFLIP
	else
		mo.flags2 = $&~MF2_OBJECTFLIP
		mo.eflags = $&~MFE_VERTICALFLIP
	end
end

T.DummySpawnLimbs = function(mo,target)
	local limb
	//Gun
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET1)
		P_InstaThrust(limb,mo.angle-ANGLE_45,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*7,false)
		limb.fuse = TICRATE
	end
	//Left Arm
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET2)
		P_InstaThrust(limb,mo.angle-ANGLE_90,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*5,false)
		limb.fuse = TICRATE
	end
	//Right arm
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET3)
		P_InstaThrust(limb,mo.angle+ANGLE_90,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*5,false)
		limb.fuse = TICRATE
	end
	//Left leg
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET4)
		P_InstaThrust(limb,mo.angle-ANGLE_90,limb.scale*3)
		P_SetObjectMomZ(limb,FRACUNIT*3,false)
		limb.fuse = TICRATE
	end
	//Right leg
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOTAGGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOTAGGIBLET5)
		P_InstaThrust(limb,mo.angle+ANGLE_90,limb.scale*3)
		P_SetObjectMomZ(limb,FRACUNIT*3,false)
		limb.fuse = TICRATE
	end
end

T.ERCThink=function(mo)
	if mo.target and mo.target.valid and mo.target.player and mo.target.player.ert_state > 0 then
		local dist = FRACUNIT*68
		local angle = -ANGLE_22h
		angle = $+mo.target.angle
		local x = mo.target.x+P_ReturnThrustX(nil,angle,dist)
		local y = mo.target.y+P_ReturnThrustY(nil,angle,dist)
		local z = mo.target.z+mo.target.scale*38
		P_TeleportMove(mo,x,y,z)
		mo.scale = mo.target.scale>>2
		if mo.target.player.ert_charged == FRACUNIT
			mo.scale = $<<1
		end
	else
		P_RemoveMobj(mo)
		T.DebugPrint("Removed charging sprite")
	end
end